=== debianbuild/reduce/debian/changelog ===
reduce (2017-05-15) unstable; urgency=low

  * New Snapshot.

 -- REDUCE Developers <reduce-algebra-developers@lists.sourceforge.net>  Mon, 15 May 2017 16:59:55 +0100

reduce (20160514) unstable; urgency=low

  * New Snapshot.

 -- REDUCE Developers <reduce-algebra-developers@lists.sourceforge.net>  Sat, 14 May 2016 16:33:05 +0100

reduce (20160410) unstable; urgency=low

  * New Snapshot.

 -- REDUCE Developers <reduce-algebra-developers@lists.sourceforge.net>  Sun, 10 Apr 2016 14:48:30 +0100

reduce (20160404) unstable; urgency=low

  * New Snapshot.

 -- REDUCE Developers <reduce-algebra-developers@lists.sourceforge.net>  Mon, 04 Apr 2016 08:47:54 +0100

reduce (20141130) unstable; urgency=low

  * New Snapshot.

 -- REDUCE Developers <reduce-algebra-developers@lists.sourceforge.net>  Sun, 30 Nov 2014 18:10:18 +0100

reduce (20120521) unstable; urgency=low

  * New Snapshot.

 -- REDUCE Developers <reduce-algebra-developers@lists.sourceforge.net>  Mon, 21 May 2012 20:57:39 +0100
